//GUI
System.Gadget.onUndock = undock;
System.Gadget.onDock = dock;
System.Gadget.background = "";

var player= document.getElementById('nolplayerWM');
var title = document.getElementById('title');
var ddesc =document.getElementById('desc');

function dock(){
	player.style.visibility='hidden';
	player.ShowControls = 'false';
	player.ShowStatusBar = '0';
	document.getElementById('state').className='docked';
	document.body.style.width='130px';
	document.body.style.height='222px';
	document.body.style.backgroundImage = 'url(images/bg-docked6.png)';
	player.style.visibility='visible';
	poll(url);
}
function undock(){
	document.getElementById('state').className='undocked';
	player.width='400';
	player.height='293';
	document.body.style.width='580px';
	document.body.style.height='330px';
	document.body.style.backgroundImage = 'url(images/bg-undocked5.png)';
	player.ShowControls = 'true';
	player.ShowStatusBar = '1';
	poll(url);
}
function setFeed(a){
	if(a.rel){
		title.innerText = a.innerText;
		player.FileName = a.rel;
		var details=a.id.split('-')[1];
		show_details(details);
		highlight(a);
	}else{
		title.innerText = 'BBC Video News';
		player.Stop();
	}
}
function show_details(el){
	var divs = document.getElementById('feed').getElementsByTagName('div');
	var j=1;
	for(var i=0;i<divs.length;i++){
		if(divs[i].id=='details-'+el&&divs[i].rel==player.FileName&&j==1){
			divs[i].style.display='block';
			j++;
		}else{
			divs[i].style.display='none';
		}
	}
}
function highlight(el){
	var a = document.getElementById('feed').getElementsByTagName('a');
	for(var i=0;i<a.length;i++){
		if(a[i]==el){
			a[i].className='on';
		}else{
			a[i].className='';
		}
	}
}
function trim(str,chars){
	if(str.length>chars+3){
		str = str.substring(0,chars);
		str = str.replace( /^\s+/g, "" );// strip leading
		str = str.replace( /\s+$/g, "" );// strip trailing
		str+='...';
	}
	return str;
}
function display_time(secs){
	var i=0;
	secs=parseInt(secs);
	while(secs>60){
		secs=secs-60;
		i++;
	}
	if(i){
		var str=i+'m '+secs+' seconds';
	}else{
		var str=secs+' seconds';
	}
	return str;

}

//AJAX
var request=false;
try{request=new XMLHttpRequest();}catch(trymicrosoft){
try{request=new ActiveXObject("Msxml2.XMLHTTP");}catch(othermicrosoft){
try{request=new ActiveXObject("Microsoft.XMLHTTP");}catch(failed){request=false;}}}

function go(url,func){
	request.open("GET",url,true);
	request.onreadystatechange=func;
	request.send('');
	//var load=setTimeout('poll()',5000);
}
function updatePage(){
	if(request.readyState==4){
		if(request.status==200){
			var xml = request.responseXML;
			var items = xml.getElementsByTagName('item');
			listItems(items);
		}
	}
}
function listItems(items){
	var div=document.getElementById('feed');
	for(var i=0;i<items.length;i++){
		var date =items[i].getElementsByTagName('pubDate')[0].text;
		var title=items[i].getElementsByTagName('title')[0].text;
		var desc =items[i].getElementsByTagName('description')[0].text;
	
		var mc = items[i].getElementsByTagName('media:content');
		for(var j=0;j<mc.length;j++){

			var type=mc[j].getAttribute('type');
			var bitrate=mc[j].getAttribute('bitrate');

			if(type=='video/x-ms-asf' && bitrate=='256'){
				var link =mc[j].getAttribute('url');
				var bitr =mc[j].getAttribute('bitrate');
				var leng =display_time(mc[j].getAttribute('duration'));
			}
		}
		
		var thumb = items[i].getElementsByTagName('media:thumbnail')[0].getAttribute('url');

		var details = document.createElement('div');
		details.id='details-'+i;
		details.className='details';
		details.setAttribute('rel',link);
		
		var image = new Image();// Image
		image.src=thumb;
		image.style.border='none';
		
		var d_date = document.createElement('p');// Date
		d_date.className='date';
		d_date.innerText = date;	
		
		var d_desc = document.createElement('p');// Description
		d_desc.innerText = desc;
		
		var d_feed1 = document.createElement('p');// Duration
		d_feed1.className='feed-details';
		d_feed1.innerText = leng;

		var d_feed2 = document.createElement('p');// Bitrate
		d_feed2.className='feed-details';
		d_feed2.innerText = bitr+'kbp/s';

		details.appendChild(image);
		details.appendChild(d_feed1);
		details.appendChild(d_feed2);
		details.appendChild(d_date);
		details.appendChild(d_desc);		

		var _a = document.createElement('a');
		_a.id='title-'+i;
		_a.setAttribute('href','javascript:void(0)');
		_a.setAttribute('rel',link);
		_a.setAttribute('title',title+'\n'+date+'\n'+desc+'\nLength: '+leng+', Bitrate: '+bitr+'kbp/s');
		_a.onclick=function(){setFeed(this)};
		if(document.getElementById('state').className=='docked'){
			_a.innerText=trim(title,22);
		}else{
			_a.innerText=title;
		}
		div.appendChild(details);
		div.appendChild(_a);

		if(player.FileName==link){
			_a.className='on';
			show_details(i);
		}
	}
}
//Polling
function poll(url){
		var f=document.getElementById('feed');
		var a=f.getElementsByTagName('a');
		for(var j=a.length-1;j>0;j--){a[j].removeNode(true);}
		var d=f.getElementsByTagName('div');
		for(var k=0;k<d.length;k++){d[k].removeNode(true);}
		var date=new Date();
		go(url+'?'+date,updatePage);
}

System.Gadget.settingsUI = "settings.htm";// Settings
System.Gadget.onSettingsClosed = SettingsClosed;

function SettingsClosed() {
	url = System.Gadget.Settings.read("rss");
	timeout=System.Gadget.Settings.read("frequency");
	poll(url);
}

var t;
var url='';
var timeout=600000; // ten minutes

if(url=System.Gadget.Settings.read("rss")){}else{url='http://newsrss.bbc.co.uk/rss/newsplayer_uk_edition/front_page/rss.xml';}
//if(timeout=System.Gadget.Settings.read("frequency")){}else{timeout=1000;}//grr

poll(url); // Load
t=setInterval("poll(url)",timeout); // Update